﻿using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace Spread_AutoFill_Handle
{
    public partial class Form1 : Form
    {
        //Contex Menu Strip corresponding to Autofill Handle in Excel
        ContextMenuStrip Autofill_Handle_ContextMenu;
        ToolStripMenuItem copyCellsToolStripMenuItem;
        ToolStripMenuItem fillSeriesToolStripMenuItem;
        ToolStripMenuItem fillFormatingOnlyToolStripMenuItem;
        ToolStripMenuItem fillWithoutFormattingToolStripMenuItem;

        int rowbegin, columnbegin;
        string direction;
        bool ctrlpressed = false;
        bool celldrag = false;
      
        public Form1()
        {
            InitializeComponent();
            this.Autofill_Handle_ContextMenu = new System.Windows.Forms.ContextMenuStrip();
            this.copyCellsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.fillSeriesToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.fillFormatingOnlyToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.fillWithoutFormattingToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();

            // 
            // Autofill_Handle_ContextMenu
            // 
            this.Autofill_Handle_ContextMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.copyCellsToolStripMenuItem,
            this.fillSeriesToolStripMenuItem,
            this.fillFormatingOnlyToolStripMenuItem,
            this.fillWithoutFormattingToolStripMenuItem});
           this.Autofill_Handle_ContextMenu.Size = new System.Drawing.Size(232, 122);
            // 
            // copyCellsToolStripMenuItem
            // 
            this.copyCellsToolStripMenuItem.Size = new System.Drawing.Size(231, 24);
            this.copyCellsToolStripMenuItem.Text = "Copy Cells";
            this.copyCellsToolStripMenuItem.Click += new System.EventHandler(this.copyCellsToolStripMenuItem_Click);
            // 
            // fillSeriesToolStripMenuItem
            // 
            this.fillSeriesToolStripMenuItem.Size = new System.Drawing.Size(231, 24);
            this.fillSeriesToolStripMenuItem.Text = "Fill Series";
            this.fillSeriesToolStripMenuItem.Click += new System.EventHandler(this.fillSeriesToolStripMenuItem_Click);
            // 
            // fillFormatingOnlyToolStripMenuItem
            // 
            this.fillFormatingOnlyToolStripMenuItem.Size = new System.Drawing.Size(231, 24);
            this.fillFormatingOnlyToolStripMenuItem.Text = "Fill Formating Only";
            this.fillFormatingOnlyToolStripMenuItem.Click += new System.EventHandler(this.fillFormatingOnlyToolStripMenuItem_Click);
            // 
            // fillWithoutFormattingToolStripMenuItem
            // 
            this.fillWithoutFormattingToolStripMenuItem.Size = new System.Drawing.Size(231, 24);
            this.fillWithoutFormattingToolStripMenuItem.Text = "Fill Without Formatting";
            this.fillWithoutFormattingToolStripMenuItem.Click += new System.EventHandler(this.fillWithoutFormattingToolStripMenuItem_Click);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1.DragFillBlock += new FarPoint.Win.Spread.DragFillBlockEventHandler(fpSpread1_DragFillBlock);
            fpSpread1.DragFillBlockCompleted += new FarPoint.Win.Spread.DragFillBlockCompletedEventHandler(fpSpread1_DragFillBlockCompleted);
            fpSpread1.KeyUp += new KeyEventHandler(fpSpread1_KeyUp);
            fpSpread1.KeyDown += new KeyEventHandler(fpSpread1_KeyDown);
            Autofill_Handle_ContextMenu.Opening += new CancelEventHandler(Autofill_Handle_ContextMenu_Opening);
            // Allowing drag and fill for spread
            fpSpread1.AllowDragFill = true;
        }

        void fpSpread1_KeyDown(object sender, KeyEventArgs e)
        {
            // to check whether CTRL key is pressed or not
            if (e.KeyCode == Keys.ControlKey)
            {
                ctrlpressed = true;
            }
        }

        void fpSpread1_KeyUp(object sender, KeyEventArgs e)
        {
            ctrlpressed = false;
        }

        void Autofill_Handle_ContextMenu_Opening(object sender, CancelEventArgs e)
        {
            // to disable the Menustrip if no cell is dragging is performed
            if (fpSpread1.ActiveSheet.GetSelection(0).ColumnCount == 1 && fpSpread1.ActiveSheet.GetSelection(0).RowCount == 1)
            {
                e.Cancel = true;
            }
        }

        
        void fpSpread1_DragFillBlockCompleted(object sender, FarPoint.Win.Spread.DragFillBlockCompletedEventArgs e)
        {
            //For implementing second requirement i.e. Auto increment/decrement by drag with CTRL key
            if (ctrlpressed == true && celldrag == true)
            {
                int num = Convert.ToInt32(fpSpread1.ActiveSheet.Cells[e.RowBegin, e.ColumnBegin].Value);
                FarPoint.Win.Spread.Cell cell = fpSpread1.ActiveSheet.Cells[e.RowBegin, e.ColumnBegin];
                int j = 1;
                if (e.Direction == FarPoint.Win.Spread.FillDirection.Down)
                {
                    for (int i = e.RowBegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).RowCount + e.RowBegin); i++)
                    {
                        fpSpread1.ActiveSheet.Cells[i, e.ColumnBegin].Value = num + j;
                        copyFormat(i, e.ColumnBegin, cell);
                        ++j;
                    }
                }

                else if (e.Direction == FarPoint.Win.Spread.FillDirection.Up)
                {
                    for (int i = e.RowBegin - 1; i > (e.RowBegin - fpSpread1.ActiveSheet.GetSelection(0).RowCount); i--)
                    {
                        fpSpread1.ActiveSheet.Cells[i, e.ColumnBegin].Value = num - j;
                        copyFormat(i, e.ColumnBegin, cell);
                        ++j;
                    }
                }

                else if (e.Direction == FarPoint.Win.Spread.FillDirection.Right)
                {
                    for (int i = e.ColumnBegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).ColumnCount + e.ColumnBegin); i++)
                    {
                        fpSpread1.ActiveSheet.Cells[e.RowBegin, i].Value = num + j;
                        copyFormat(e.RowBegin, i, cell);
                        ++j;
                    }
                }

                else if (e.Direction == FarPoint.Win.Spread.FillDirection.Left)
                {
                    for (int i = e.ColumnBegin - 1; i > (e.ColumnBegin - fpSpread1.ActiveSheet.GetSelection(0).ColumnCount); i--)
                    {
                        fpSpread1.ActiveSheet.Cells[e.RowBegin, i].Value = num - j;
                        copyFormat(e.RowBegin, i, cell);
                        ++j;
                    }
                }
            }
            else
            {
                celldrag = false;
                rowbegin = e.RowBegin;
                columnbegin = e.ColumnBegin;
                direction = e.Direction.ToString();
                copyCellsToolStripMenuItem_Click(null, null);
            }
      }

        void fpSpread1_DragFillBlock(object sender, FarPoint.Win.Spread.DragFillBlockEventArgs e)
        {
            fpSpread1.ContextMenuStrip = Autofill_Handle_ContextMenu;
            celldrag = true;
        }

        void copyFormat(int row, int col, FarPoint.Win.Spread.Cell cell)
        {
            //Copying the formatting of cell
            fpSpread1.ActiveSheet.Cells[row, col].BackColor = cell.BackColor;
            fpSpread1.ActiveSheet.Cells[row, col].ForeColor = cell.ForeColor;
            fpSpread1.ActiveSheet.Cells[row, col].Font = cell.Font;
        }

        private void copyCellsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Copy complete cell along with formatting
            FarPoint.Win.Spread.Cell cell = fpSpread1.ActiveSheet.Cells[rowbegin, columnbegin];
            if (direction == "Down")
            {   
                for (int i = rowbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).RowCount + rowbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Value  = cell.Value;
                    copyFormat(i, columnbegin, cell);
               }
            }
            else if (direction == "Up")
            {
                for (int i = rowbegin - 1; i > (rowbegin - fpSpread1.ActiveSheet.GetSelection(0).RowCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Value = cell.Value;
                    copyFormat(i, columnbegin, cell);
                }
            }

            else if (direction == "Right")
            {
                for (int i = columnbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).ColumnCount + columnbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Value = cell.Value;
                    copyFormat(rowbegin, i,cell);
                }
            }

            else if (direction == "Left")
            {
                for (int i = columnbegin - 1; i > (columnbegin - fpSpread1.ActiveSheet.GetSelection(0).ColumnCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Value = cell.Value;
                    copyFormat(rowbegin, i, cell);
                }
            }
        }

        private void fillSeriesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Fill Series i.e. Auto Increment/Decrement
            int num = Convert.ToInt32(fpSpread1.ActiveSheet.Cells[rowbegin, columnbegin].Value);
            int j = 1;
            if (direction == "Down")
            {
                for (int i = rowbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).RowCount + rowbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Value = num + j;
                    ++j;
                }
            }

            else if (direction == "Up")
            {
                for (int i = rowbegin - 1; i > (rowbegin - fpSpread1.ActiveSheet.GetSelection(0).RowCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Value = num - j;
                    ++j;
                }
            }

            else if (direction == "Right")
            {
                for (int i = columnbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).ColumnCount + columnbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Value = num + j;
                    ++j;
                }
            }

            else if (direction == "Left")
            {
                for (int i = columnbegin - 1; i > (columnbegin   - fpSpread1.ActiveSheet.GetSelection(0).ColumnCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Value = num - j;
                    ++j;
                }
            }
        }

        private void fillFormatingOnlyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Copying only formatting
            FarPoint.Win.Spread.Cell cell = fpSpread1.ActiveSheet.Cells[rowbegin, columnbegin];
            if (direction == "Down")
            {
                for (int i = rowbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).RowCount + rowbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Value = null;
                    copyFormat(i, columnbegin, cell);
                }
            }
            else if (direction == "Up")
            {
                for (int i = rowbegin - 1; i > (rowbegin - fpSpread1.ActiveSheet.GetSelection(0).RowCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Value = null;
                    copyFormat(i, columnbegin, cell);
                }
            }

            else if (direction == "Right")
            {
                for (int i = columnbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).ColumnCount + columnbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Value = null;
                    copyFormat(rowbegin, i, cell);
                }
            }

            else if (direction == "Left")
            {
                for (int i = columnbegin - 1; i > (columnbegin - fpSpread1.ActiveSheet.GetSelection(0).ColumnCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Value = null;
                    copyFormat(rowbegin, i, cell);
                }
            }
        }

        private void fillWithoutFormattingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //copying only formatting not data
            FarPoint.Win.Spread.Cell cell = fpSpread1.ActiveSheet.Cells[rowbegin, columnbegin];
            if (direction == "Down")
            {
                for (int i = rowbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).RowCount + rowbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Value = cell.Value;
                    NoFormat(i, columnbegin);
                }
            }
            else if (direction == "Up")
            {
                for (int i = rowbegin - 1; i > (rowbegin - fpSpread1.ActiveSheet.GetSelection(0).RowCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Value = cell.Value;
                }
            }

            else if (direction == "Right")
            {
                for (int i = columnbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).ColumnCount + columnbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Value = cell.Value;
                }
            }

            else if (direction == "Left")
            {
                for (int i = columnbegin - 1; i > (columnbegin - fpSpread1.ActiveSheet.GetSelection(0).ColumnCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Value = cell.Value;
                }
            }
        }

        void NoFormat(int row, int col)
        {
            //Copying the formatting of cell
            fpSpread1.ActiveSheet.Cells[row, col].BackColor = System.Drawing.Color.Transparent;
            fpSpread1.ActiveSheet.Cells[row, col].ForeColor = System.Drawing.Color.Black;
            fpSpread1.ActiveSheet.Cells[row, col].Font = new System.Drawing.Font("Microsoft Sans Serif", 7.8f);
        }
    }
}
